#! /bin/sh

echo "Analysis Tests"
echo

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]
then
    ../ds9&
fi

i=1
while [ "$i" -le 15 ]
do
    sleep 1
    if [ `xpaaccess ds9` = yes ]
    then
	break
    fi

    i=`expr $i + 1`
done

echo "Testing Text/Plot"
echo "This is a Test Text Message" | xpaset ds9 analysis text
cat xy.dat | xpaset ds9 analysis plot
cat xyee.dat | xpaset ds9 analysis plot "{Plot Test}" X Y xyee
cat xye.stdin.dat | xpaset ds9 analysis plot stdin
xpaset -p ds9 raise
echo "PASSED"

# Analysis

echo "Testing Analysis File"
xpaset -p ds9 file img16.fits
xpaset -p ds9 regions file analysis.reg
xpaset -p ds9 analysis load analysis.ans
xpaget ds9 analysis > /dev/null

# Main

echo "Help"
xpaset -p ds9 analysis 1

# Basics

echo "Basic"
xpaset -p ds9 analysis 2
echo "..escape macro"
xpaset -p ds9 analysis 3
echo "..non macro"
xpaset -p ds9 analysis 4
echo "..\$xpa"
xpaset -p ds9 analysis 5
echo "..\$xpa_method"
xpaset -p ds9 analysis 6
echo "..\$filename"
xpaset -p ds9 analysis 7
echo "..\$filename(root)"
xpaset -p ds9 analysis 8
echo "..\$xdim $ydim $bitpix"
xpaset -p ds9 analysis 9

# Regions

echo "Regions"
xpaset -p ds9 analysis 10
echo "..\$regions"
xpaset -p ds9 analysis 11
echo "..\$regions wcs"
xpaset -p ds9 analysis 12
echo "..\$include_regions_pixels"
xpaset -p ds9 analysis 13
echo "..\$filename $regions"
xpaset -p ds9 analysis 14
echo "..\$regions()"
xpaset -p ds9 analysis 15

# Output

echo "Output"
xpaset -p ds9 analysis 16
echo "..\$null"
xpaset -p ds9 analysis 17
echo "..\$text"
xpaset -p ds9 analysis 18
echo "..\$plot"
xpaset -p ds9 analysis 19
echo "..\$plot(title,x,y,xye)"
xpaset -p ds9 analysis 20
echo "..\$plot(title,x,y,xyee)"
xpaset -p ds9 analysis 21
echo "..\$plot(title,x,y,4)"
xpaset -p ds9 analysis 22
echo "..\$plot(title,x,y,5)"
xpaset -p ds9 analysis 23
echo "..\$plot(stdin)"
xpaset -p ds9 analysis 24
echo "..\$plot(stdin) text"
xpaset -p ds9 analysis 25
echo "..\$plot(stdin) error"
xpaset -p ds9 analysis 26
echo "..\$data"
xpaset -p ds9 analysis 27
echo "..\$image"
xpaset -p ds9 analysis 28

# Dialogs

echo "Dialog"
xpaset -p ds9 analysis 29
echo "..\$message(message)"
xpaset -p ds9 analysis 30
echo "..\$message(ok,message)"
xpaset -p ds9 analysis 31
echo "..\$entry(message)"
xpaset -p ds9 analysis 32

# Params

echo "Param"
xpaset -p ds9 analysis 33
echo "..\$param"
xpaset -p ds9 analysis 34
echo "..\$param @file"
xpaset -p ds9 analysis 35

echo "PASSED"

# Other

xpaset -p ds9 analysis message {press 'x','y','z' to test interactive}

#xpaset -p ds9 quit
echo "Done"
