#! /bin/sh

KillIt () {
    i=1
    while [ "$i" -le 15 ]
    do
        sleep 1
        if [ `xpaaccess ds9` = yes ]
        then
	    sleep 1
	    xpaset -p ds9 quit
	    break
        fi

        i=`expr $i + 1`
    done
}

StartDS9 () {
    if [ `xpaaccess ds9` = no ]; then
	../ds9&

	i=1
	while [ "$i" -le 15 ]
	    do
	    sleep 1
	    if [ `xpaaccess ds9` = yes ]; then
		break
	    fi

	    i=`expr $i + 1`
	done
    fi
}

# Fits

if [ "$1" = "fits" -o  -z "$1" ]; then
echo "Testing Fits"

StartDS9
xpaset -p ds9 scale zscale

echo "..Bitpix = 8"
xpaset -p ds9 file fits img8.fits
sleep 1
xpaset -p ds9 frame clear

echo "..Bitpix = 16"
xpaset -p ds9 file fits img16.fits
sleep 1
xpaset -p ds9 frame clear

echo "..Bitpix = 32"
xpaset -p ds9 file fits img32.fits
sleep 1
xpaset -p ds9 frame clear

echo "..Bitpix = -32"
xpaset -p ds9 file fits img-32.fits
sleep 1
xpaset -p ds9 frame clear

echo "..Bitpix = -64"
xpaset -p ds9 file fits img-64.fits
sleep 1
xpaset -p ds9 frame clear

echo "..BSCALE"
xpaset -p ds9 file fits imgbscale.fits
sleep 1
xpaset -p ds9 frame clear

echo "..BLANK"
xpaset -p ds9 file fits imgblank.fits
sleep 1
xpaset -p ds9 frame clear

echo "..NaN"
xpaset -p ds9 file fits imgnan.fits
sleep 1
xpaset -p ds9 frame clear

echo "..INF"
xpaset -p ds9 file fits imginf.fits
sleep 1
xpaset -p ds9 frame clear

xpaset -p ds9 quit
echo "PASSED"

fi

# Command Line

if [ "$1" = "command" -o  -z "$1" ]; then
echo "Testing Command Line File"

echo "..fits"
../ds9 -zscale img16.fits&
KillIt

echo "..fits gz"
../ds9 -zscale img16.fits.gz &
KillIt

echo "..table"
../ds9 -zscale table.fits &
KillIt

echo "..table filter"
../ds9 -zscale table.fits[bin=rawx,rawy] &
KillIt

echo "..array"
 ../ds9 -array 'array.arr[dim=512,bitpix=-32,arch=bigendian]' &
KillIt

echo "..array cube"
 ../ds9 -array 'cube.arr[dim=512,zdim=3,bitpix=-32,arch=bigendian]' &
KillIt

echo "..multiple extension data cube"
../ds9 -zscale -medatacube mosaicimage.fits &
KillIt

echo "..mosaic image iraf"
../ds9 -zscale -mosaicimage iraf mosaicimage.fits &
KillIt

echo "..mosaic image wcs"
../ds9 -zscale -mosaicimage wcs mosaicimage.fits &
KillIt

echo "..mosaic image next wcs"
../ds9 -zscale -mosaicimage wcs mosaicimage.fits -mosaicimagenext wcs mosaicimage.fits &
KillIt

echo "..mosaic image wcsp"
../ds9 -zscale -mosaicimage wcsp ds9_8amp_2x2.fits&
KillIt

echo "..mosaic image wfpc2"
../ds9 -zscale -mosaicimage wfpc2 hst.fits &
KillIt

echo "..mosaic iraf"
../ds9 -zscale -mosaic iraf mosaicimage.fits &
KillIt

echo "..mosaic wcs"
../ds9 -zscale -mosaic wcs mosaicimage.fits &
KillIt

echo "..mosaic wcsp"
../ds9 -zscale -mosaic wcsp ds9_8amp_2x2.fits &
KillIt

echo "..mosaic image iraf(bc)"
../ds9 -zscale -mosaicimageiraf mosaicimage.fits &
KillIt

echo "..mosaic image wcs(bc)"
../ds9 -zscale -mosaicimagewcs mosaicimage.fits &
KillIt

echo "..mosaic image wfpc2(bc)"
../ds9 -zscale -mosaicimagewfpc2 hst.fits &
KillIt

echo "..mosaic image next wcs(bc)"
../ds9 -zscale -mosaicimagewcs mosaicimage.fits -mosaicimagenextwcs mosaicimage.fits &
KillIt

echo "..mosaic iraf(bc)"
../ds9 -zscale -mosaiciraf mosaicimage.fits &
KillIt

echo "..mosaic wcs(bc)"
../ds9 -zscale -mosaicwcs mosaicimage.fits &
KillIt

echo "..rgb cube"
../ds9 -rgbcube rgbcube.fits &
KillIt

echo "..rgb image"
../ds9 -rgbimage rgbimage.fits &
KillIt

echo "..rgb array"
../ds9 -rgbarray rgb.arr[dim=200,zdim=3,bitpix=8] &
KillIt

echo "..url ftp"
../ds9 -zscale -url 'ftp://sao-ftp.harvard.edu/pub/rd/ds9/data/img-32.fits' &
KillIt

echo "..url http"
../ds9 -zscale -url 'http://hea-www.harvard.edu/RD/ds9/data/img-32.fits' &
KillIt

echo "..external"
../ds9 foo.bar&
KillIt

echo "PASSED"
fi

# Stdin

if [ "$1" = "stdin" -o  -z "$1" ]; then
echo "Testing Stdin File"

echo "..fits"
cat img16.fits | ../ds9 -zscale - &
KillIt

echo "..fits gz"
cat img16.fits.gz | ../ds9 -zscale - &
KillIt

echo "..table"
cat table.fits | ../ds9 -zscale - &
KillIt

echo "..table filter"
cat table.fits | ../ds9 -zscale -[bin=rawx,rawy] &
KillIt

echo "..array"
cat array.arr | ../ds9 -array '-[dim=512,bitpix=-32,arch=bigendian]' &
KillIt

echo "..array cube"
cat cube.arr | ../ds9 -array '-[dim=512,zdim=3,bitpix=-32,arch=bigendian]' &
KillIt

echo "..multiple extension data cube"
cat mosaicimage.fits | ../ds9 -zscale -medatacube - &
KillIt

echo "..mosaic image iraf"
cat mosaicimage.fits | ../ds9 -zscale -mosaicimage iraf - &
KillIt

echo "..mosaic image wcs"
cat mosaicimage.fits | ../ds9 -zscale -mosaicimage wcs - &
KillIt

echo "..mosaic image wcsp"
cat ds9_8amp_2x2.fits | ../ds9 -zscale -mosaicimage wcsp - &
KillIt

echo "..mosaic image wfpc2"
cat hst.fits | ../ds9 -zscale -mosaicimage wfpc2 - &
KillIt

echo "..mosaic iraf"
cat mosaicimage.fits | ../ds9 -zscale -mosaic iraf - &
KillIt

echo "..mosaic wcs"
cat mosaicimage.fits | ../ds9 -zscale -mosaic wcs - &
KillIt

echo "..mosaic wcsp"
cat ds9_8amp_2x2.fits | ../ds9 -zscale -mosaic wcsp - &
KillIt

echo "..mosaic image iraf(bc)"
cat mosaicimage.fits | ../ds9 -zscale -mosaicimageiraf - &
KillIt

echo "..mosaic image wcs(bc)"
cat mosaicimage.fits | ../ds9 -zscale -mosaicimagewcs - &
KillIt

echo "..mosaic image wfpc2(bc)"
cat hst.fits | ../ds9 -zscale -mosaicimagewfpc2 - &
KillIt

echo "..mosaic iraf(bc)"
cat mosaicimage.fits | ../ds9 -zscale -mosaiciraf - &
KillIt

echo "..mosaic wcs(bc)"
cat mosaicimage.fits | ../ds9 -zscale -mosaicwcs - &
KillIt

echo "..rgb cube"
cat rgbcube.fits | ../ds9 -rgbcube - &
KillIt

echo "..rgb image"
cat rgbimage.fits | ../ds9 -rgbimage - &
KillIt

echo "..rgb array"
cat rgb.arr | ../ds9 -rgbarray -[dim=200,zdim=3,bitpix=8] &
KillIt

echo "PASSED"
fi

# XPA
if [ "$1" = "xpa" -o  -z "$1" ]; then
echo "Testing XPA"

StartDS9
xpaset -p ds9 scale zscale

echo "Testing file"
echo "..fits"
xpaset -p ds9 file fits img16.fits
sleep 1
xpaset -p ds9 frame clear

echo "..fits gz"
xpaset -p ds9 file fits img16.fits.gz
sleep 1
xpaset -p ds9 frame clear

echo "..table"
xpaset -p ds9 scale log
xpaset -p ds9 scale minmax
xpaset -p ds9 file fits table.fits
xpaset -p ds9 bin factor 8
sleep 1
xpaset -p ds9 frame clear

echo "..table filter"
xpaset -p ds9 file fits table.fits[bin=rawx,rawy]
sleep 1
xpaset -p ds9 frame clear
xpaset -p ds9 scale linear
xpaset -p ds9 scale zscale

echo "..array"
xpaset -p ds9 file array 'array.arr[dim=512,bitpix=-32,arch=bigendian]'
sleep 1
xpaset -p ds9 frame clear

echo "..array cube"
xpaset -p ds9 file array 'cube.arr[dim=512,zdim=3,bitpix=-32,arch=bigendian]'
sleep 1
xpaset -p ds9 frame clear

echo "..multiple extension data cube"
xpaset -p ds9 file medatacube mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image iraf"
xpaset -p ds9 file mosaicimage iraf mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcs"
xpaset -p ds9 file mosaicimage wcs mosaicimage.fits
sleep 1

echo "..mosaic image next wcs"
xpaset -p ds9 file mosaicimagenext wcs mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcsp"
xpaset -p ds9 file mosaicimage wcsp ds9_8amp_2x2.fits
sleep 1

echo "..mosaic image wfpc2"
xpaset -p ds9 file mosaicimage wfpc2 hst.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic iraf"
xpaset -p ds9 file mosaic iraf mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcs"
xpaset -p ds9 file mosaic wcs mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcsp"
xpaset -p ds9 file mosaic wcsp ds9_8amp_2x2.fits
sleep 1

echo "..mosaic image iraf(bc)"
xpaset -p ds9 file mosaicimageiraf mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcs(bc)"
xpaset -p ds9 file mosaicimagewcs mosaicimage.fits
sleep 1

echo "..mosaic image next wcs(bc)"
xpaset -p ds9 file mosaicimagenextwcs mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wfpc2(bc)"
xpaset -p ds9 file mosaicwfpc2 hst.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic iraf(bc)"
xpaset -p ds9 file mosaiciraf mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcs(bc)"
xpaset -p ds9 file mosaicwcs mosaicimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..rgb cube"
xpaset -p ds9 scale minmax
xpaset -p ds9 rgb
xpaset -p ds9 file rgbcube rgbcube.fits
sleep 1
xpaset -p ds9 frame clear

echo "..rgb image"
xpaset -p ds9 file rgbimage rgbimage.fits
sleep 1
xpaset -p ds9 frame clear

echo "..rgb array"
xpaset -p ds9 file rgbarray rgb.arr[dim=200,zdim=3,bitpix=8]
sleep 1
xpaset -p ds9 frame clear
xpaset -p ds9 frame delete
xpaset -p ds9 scale zscale

#echo "..url ftp"
#xpaset -p ds9 file url 'ftp://sao-ftp.harvard.edu/pub/rd/ds9/data/img-32.fits'&
#sleep 5
#xpaset -p ds9 frame clear

#echo "..url http"
#xpaset -p ds9 file url 'http://hea-www.harvard.edu/RD/ds9/data/img-32.fits'&
#sleep 5
#xpaset -p ds9 frame clear

echo "..external"
xpaset -p ds9 file foo.bar
sleep 5
xpaset -p ds9 frame clear

echo "Testing Array"
echo "..array"

xpaset -p ds9 scale minmax

cat array.arr | xpaset ds9 array 'array.arr[dim=512,bitpix=-32,arch=bigendian]'
sleep 1
xpaset -p ds9 frame clear

echo "..array cube"
cat cube.arr | xpaset ds9 array 'arraycube.arr[dim=512,zdim=3,bitpix=-32,arch=bigendian]'
sleep 1
xpaset -p ds9 frame clear

echo "..array rgb"
cat rgb.arr | xpaset ds9 array new rgb 'rgb.arr[dim=200,zdim=3,bitpix=8]'
sleep 1
xpaset -p ds9 frame delete

xpaset -p ds9 scale zscale

echo "Testing Fits"
echo "..fits"
cat img16.fits | xpaset ds9 fits
sleep 1
xpaset -p ds9 frame clear

echo "..fits gz"
cat img16.fits.gz | xpaset ds9 fits
sleep 1
xpaset -p ds9 frame clear

echo "..table"
xpaset -p ds9 scale log
xpaset -p ds9 scale minmax
cat table.fits | xpaset ds9 fits
xpaset -p ds9 bin factor 8
sleep 1
xpaset -p ds9 frame clear

echo "..table filter"
cat table.fits | xpaset ds9 fits 'table.fits[bin=rawx,rawy]'
sleep 1
xpaset -p ds9 frame clear
xpaset -p ds9 scale linear
xpaset -p ds9 scale zscale

echo "..multiple extension data cube"
cat mosaicimage.fits | xpaset ds9 fits medatacube foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image iraf"
cat mosaicimage.fits | xpaset ds9 fits mosaicimage iraf foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcs"
cat mosaicimage.fits | xpaset ds9 fits mosaicimage wcs foo
sleep 1

echo "..mosaic image next wcs"
cat mosaicimage.fits | xpaset ds9 fits mosaicimagenext wcs foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcsp"
cat ds9_8amp_2x2.fits | xpaset ds9 fits mosaicimage wcsp foo
sleep 1

echo "..mosaic image wfpc2"
cat hst.fits | xpaset ds9 fits mosaicimage wfpc2 foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic iraf"
cat mosaicimage.fits | xpaset ds9 fits mosaic iraf bar
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcs"
cat mosaicimage.fits | xpaset ds9 fits mosaic wcs bar
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcsp"
cat ds9_8amp_2x2.fits | xpaset ds9 fits mosaic wcsp bar
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image iraf(bc)"
cat mosaicimage.fits | xpaset ds9 fits mosaicimageiraf foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wcs(bc)"
cat mosaicimage.fits | xpaset ds9 fits mosaicimagewcs foo
sleep 1

echo "..mosaic image next wcs(bc)"
cat mosaicimage.fits | xpaset ds9 fits mosaicimagenextwcs foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic image wfpc2(bc)"
cat hst.fits | xpaset ds9 fits mosaicimagewfpc2 foo
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic iraf(bc)"
cat mosaicimage.fits | xpaset ds9 fits mosaiciraf bar
sleep 1
xpaset -p ds9 frame clear

echo "..mosaic wcs(bc)"
cat mosaicimage.fits | xpaset ds9 fits mosaicwcs bar
sleep 1
xpaset -p ds9 frame clear

echo "..rgb cube"
xpaset -p ds9 scale minmax
xpaset -p ds9 rgb
cat rgbcube.fits | xpaset ds9 fits rgbcube
sleep 1
xpaset -p ds9 frame clear

echo "..rgb image"
cat rgbimage.fits | xpaset ds9 fits rgbimage
sleep 1
xpaset -p ds9 frame delete

xpaset -p ds9 quit
echo "PASSED"
fi

echo "DONE"
